/* esSommaDiag.cpp

   Scrivere una funzione int somma_diag(const int mat[][3]) 
   che prende in ingresso una matrice quadrata di interi di 
   dimensione 3x3, e restituisce la somma degli elementi sulle 
   diagonali principale e secondaria. Lelemento 
   centrale deve essere sommato solo una volta.
   Nota: Realizzare la funzione tramite cicli.

   Scrivere un programma che: 
    dichiara una matrice 3x3 di numeri interi; 
    chiede all'utente di digitare da tastiera 9 numeri interi
   e li inserisce nella matrice per righe;
    invoca la funzione somma_diag(...), passando la matrice
   come argomento;
    stampa a video il valore restituito dalla funzione.

   Output di esempio:
   Inserisci 9 interi:
   1 
   2 
   3 
   4 
   1 
   6 
   7 
   8 
   1
   La somma degli elementi sulla diag. princ. e sec. e': 13

*********************************************************/

#include <iostream>
using namespace std;

const int DIM = 3;

int somma_diag(const int mat[][DIM]) 
{
   int somma = 0; 
   for (int i = 0; i < DIM; i++) 
   {
      for (int j = 0; j < DIM; j++)
      {
         // somma l'elemento solo se si trova 
         // sulla diagonale principale (j==i)
         // o su quella secondaria (j+i == DIM-1)
         if ( ( j==i ) || ( j+i == DIM-1 ) )
            somma += mat[i][j]; 
      }
   }
   return somma;
}

int main()
{
   int M[DIM][DIM];
   int d;

   cout<<"Inserisci "<< DIM*DIM <<" elementi"<<endl;

   for (int i = 0; i < DIM; i++)
      for (int j = 0; j < DIM; j++)
         cin >> M[i][j];

   d = somma_diag(M);    // equivalente a somma_diag(&M[0]);
   cout<<"La somma degli elementi diag.  princ. e sec. e': " << d << endl;  

   return 0;
}
