/* esSommaDiag_v2.cpp

   Scrivere una funzione int somma_diag(const int* mat, int n) 
   che prende in ingresso una matrice quadrata di interi di 
   dimensione nxn, e restituisce la somma degli elementi sulle 
   diagonali principale e secondaria. Leventuale elemento 
   centrale deve essere sommato solo una volta.

   Scrivere un programma che: 
    dichiara una matrice 3x3 di numeri interi; 
    chiede all'utente di digitare da tastiera 9 numeri interi
   e li inserisce nella matrice per righe;
    invoca la funzione somma_diag(...), passando la matrice
   come argomento;
    stampa a video il valore restituito dalla funzione.

   Output di esempio:
   Inserisci 9 interi:
   1 
   2 
   3 
   4 
   1 
   6 
   7 
   8 
   1
   La somma degli elementi sulla diag. princ. e sec. e': 13

*********************************************************/

#include <iostream>
using namespace std;

int somma_diag(const int* mat, int n) 
{
   int somma = 0; 
   for (int i = 0; i < n; i++) 
   {
      for (int j = 0; j < n; j++)
      {
         // somma l'elemento solo se si trova sulla diagonale 
         // principale (j==i) o quella secondaria (j+i == n-1).
         if ( ( j==i ) || ( j+i == n-1 ) )
            somma += mat[i*n + j]; // alternativa con matematica dei puntatori: somma += *(mat+i*n + j);
      }
   }
   return somma;
}

int main()
{
   const int dim =3;
   int M[dim][dim];
   int d;
   
   cout<<"Inserisci "<< dim*dim <<" elementi"<<endl;

   for (int i = 0; i < dim; i++)
      for (int j = 0; j < dim; j++)
         cin >> M[i][j];

   // cambio di tipo da "array di array" (int M[3][3]) ad "array linearizzato" (int* M), 
   // questo funziona perche' C++ memorizza gli array di array in modo row-wise.
   d = somma_diag(&M[0][0], dim);
   cout<<"La somma degli elementi diag.  princ. e sec. e': " << d << endl;  

   return 0;
}
