/* esMatriceTrasposta.cpp

   Scrivere una funzione int* trasposta(const int* matr, int n) che, 
   data una matrice di interi nxn memorizzata in un unico vettore, 
   restituisce come valore di ritorno la matrice trasposta, cioe' 
   la matrice ottenuta scambiando le righe con le colonne.
   Ad esempio, se la matrice e':
   1 2 3
   4 5 6
   7 8 9
   La trasposta sara':
   1 4 7
   2 5 8
   3 6 9

   Scrivere un programma che:
   - dichiara una matrice di interi 3x3; 
   - acquisisce da tastiera i 9 elementi di tale matrice, per righe;
   - stampa a video tale matrice;
   - applica la funzione trasposta(...) su tale matrice;
   - stampa a video la matrice trasposta.

   Output di esempio:
   Inserisci 9 elementi
   1
   2
   3
   4
   5
   6
   7
   8
   9
   Matrice di partenza:
   1       2       3
   4       5       6
   7       8       9
   Matrice trasposta:
   1       4       7
   2       5       8
   3       6       9
*********************************************************/

#include <iostream>
using namespace std;

int* trasposta(const int* matr, int n) {

    int* ris = new int[n*n];
    
    for(int i = 0; i < n; i++)
        for(int j = 0; j < n; j++)
            ris[i*n+j] = matr[j*n+i];

    return ris;
}


int main(){
   
   const int DIM = 3;

   int matr[DIM*DIM];

   // Prende da tastiera una matrice di interi 3x3
   cout << "Inserisci " << DIM * DIM << " elementi" << endl;
   for (int i = 0; i < DIM; i++)
        for (int j = 0; j < DIM; j++)
            cin >> matr[i*DIM+j];

   // Stampa la matrice di partenza
   cout << endl << "Matrice di partenza:" << endl;
   for (int i = 0; i < DIM; i++) {
        for (int j = 0; j < DIM; j++)
            cout << matr[i*DIM+j] << '\t';
        cout << endl;
   }
        
   // Dichiarazione del puntatore che puntera alla matrice restituita dalla funzione
   int *tr;

   // Invocazione della funzione
   tr = trasposta(matr, DIM);

   // Stampa la matrice trasposta
   cout << endl << "Matrice trasposta:" << endl;
   for (int i = 0; i < DIM; i++) {
        for (int j = 0; j < DIM; j++)
            cout << tr[i*DIM+j] << '\t';
        cout << endl;
   }

  // deallocazione
  delete[] tr;

  return 0;
}
