/* esMoltiplicazioneMatriceVettore.cpp

   Scrivere una funzione mulMatVect(...) che prende in ingresso 
   una matrice 3x3 di interi e un vettore di 3 interi 
   e ne restituisce la moltiplicazione matrice x vettore colonna, come
   valore di ritorno (non come argomento). 
   Un esempio di moltiplicazione matrice x vettore colonna e' il seguente:
   
       1 2 3          10
   M = 4 5 6      v = 20
       7 8 9          30
         1*10+2*20+3*30       140
   M*v = 4*10+5*20+6*30   =   320
         7*10+8*20+9*30       500

   Scrivere un programma che prende da tastiera i 9 elementi della matrice 3x3,
   poi prende da tastiera i 3 elementi del vettore, invoca la funzione mulMatVect
   per calcolarne la moltiplicazione matrice x vettore colonna, 
   e infine stampa il risultato.
   
   Output di esempio:

   Inserisci i 9 elementi della matrice
   1 2 3 4 5 6 7 8 9

   Inserisci i 3 elementi del vettore colonna
   10 
   20
   30

   Risultato:
   140     
   320
   500

*********************************************************/
#include <iostream>
using namespace std;

const int DIM = 3;
  
void mulMatVect(const int m[][DIM], const int v[], int*& res)
{
  // NOTA: passaggio per riferimento del puntatore a intero    

  // la moltiplicazione restituisce un vettore di 3 elementi
  res = new int[DIM];     // NOTA: allocazione dinamica!
                        // la matrice deve essere restituita al chiamante

  for (int i = 0; i < DIM; i++)
  {
      // Calcola un elemento del vettore
      res[i] = 0;
      for (int j = 0; j < DIM; j++)
	    res[i] += m[i][j] * v[j];
  }
}

int main()
{

  int matr[DIM][DIM];
  int vect[DIM];

  // Prende da tastiera una matrice di interi 3x3
  cout << "Inserisci " << DIM * DIM << " elementi" << endl;
  for (int i = 0; i < DIM; i++)
    for (int j = 0; j < DIM; j++)
      cin >> matr[i][j];

  // Prende da tastiera un vettore di DIM interi
  cout << "Inserisci " << DIM << " elementi" << endl;
  for (int i = 0; i < DIM; i++)
    cin >> vect[i];

  // Dichiarazione del puntatore che conterra’ la matrice restituita dalla funzione
  int *res;

  // Invocazione della funzione
  mulMatVect(matr, vect, res);

  // Stampa il risultato della moltiplicazione matrice x vettore colonna
  cout << "Risultato:" << endl;
  for (int i = 0; i < DIM; i++)
    cout << res[i] << endl;

  // deallocazione
  delete[] res;

  return 0;
}