/******************************************************************************
Realizzare un tipo coda che pu contenere un massimo di 10 interi.
Realizzare tre funzioni: 
    void init(coda& c), che inizializza una coda
    bool push(coda& c, int v), che inserisce un elemento in coda e restituisce 
        true se l'operazione ha avuto successo, false altrimenti.
    bool pop(coda& c, int& v), che estrae un elemento dalla coda e restituisce
        true se l'operazione ha avuto successo, false altrimenti.
Realizzare un programma che prende da tastiera 10 interi, e per ognuno lo
inserisce in una coda 'pari' se pari o in una coda 'dispari' se dispari.
Poi, estrae e stampa tutti gli elementi della coda 'pari' e tutti gli elementi
della coda 'dispari'.

Output di esempio:

Inserisci 10 numeri:
6 7 1 3 9 5 0 2 4 1
Elementi pari:
6 0 2 4 
Elementi dispari:
7 1 3 9 5 1
*******************************************************************************/

#include <iostream>
using namespace std;

struct coda
{
    int front,back;
    int queue[11]; // bisogna considerare un elemento in piu'
                   // altrimenti non si possono distinguere i 
                   // casi di coda vuota e coda piena
};

void init(coda& c)
{
    c.front = 0;
    c.back = 0;
}

bool insqueue(coda& c, int v)
{
    if(c.front == (c.back+1)%11) 
        return false;
    c.queue[c.back] = v;
    c.back = (c.back+1)%11;
    return true;
}

bool esqueue(coda& c, int& v)
{
    if(c.front == c.back) 
        return false;
    v = c.queue[c.front];
    c.front = (c.front+1)%11;
    return true;
}

int main()
{
    coda pari;
    coda dispari;
    int a;
    
    init(pari);
    init(dispari);
    
    cout << "Inserisci 10 numeri:" << endl;
    for(int i = 0; i < 10; i++)
    {
        cin >> a;
        if(a%2 == 0)
            insqueue(pari, a);
        else
            insqueue(dispari, a);
    }

    cout << "Elementi pari:" << endl;
    while(esqueue(pari, a))
        cout << a << ' ';

    cout << endl;
    
    cout << "Elementi dispari:" << endl;
    while(esqueue(dispari, a))
        cout << a << ' ';
    
    return 0;
}
